<?php
include_once("config.php");
include_once("ubroker.php");

// This is a list of the settings that can be editied.  Here is the scoop.
// The fields are labelled by the setting, so adding a setting will automatically
// add to the screen below.  The name of the fields in the form are also generated 
// from this setting.
// When calling SetDefintion() in the MngUBroker class, it expects an array of
// settings and their values, so this scheme works all the way through the system.
// Note you can set a default behind an = sign.

// We control the mode of the page with $Action.  If $Action is read, we are pulling in
// definition from the ubroker.properties file.  If it is Update then we are writing
// a revised definition to the ubroker.properties file.  Otherwise, we assume it to be
// a new definition.

$Settings = array("appserviceNameList=YourNameHere",

                  "srvrStartupParam=-p web/objects/web-disp.p -weblogerror", 
                  "fileUploadDirectory=",
                  "srvrAppMode=Development",  				  
                  "operatingMode=Stateless",
                  "srvrDebug=Enabled",
                  "defaultService=0",
                  "defaultCookiePath=",
                  "defaultCookieDomain=",
                  "4glSrcCompile=0",
                  "applicationURL=",
                  "description=WebSpeed Broker",
                  "uuid=",
				  
                  "srvrLogFile=/var/webspeed/YourBrokerName.server.log",
                  "srvrLogAppend=1",
                  "srvrLoggingLevel=2",				  
				  
				  "brokerLogFile=/var/webspeed/YourBrokerName.broker.log",
                  "brkrLogAppend=1",
                  "brkrLoggingLevel=2",
				  
                  "controllingNameServer=NS1",
				  
                  "environment=",   // Editing Environments destined for version 2
				  
                  "userName=",
                  "groupName=",

                  "workDir=/appl/src",
                  "PROPATH=\${PROPATH}:",
				  
                  "initialSrvrInstance=2",
                  "maxSrvrInstance=5",
                  "minSrvrInstance=1",
 
                  "portNumber=3070",
                  "srvrMaxPort=3502",
                  "srvrMinPort=3202",
				      
                  "registrationMode=Register-IP",


                  "autoStart=0"
);

$Manager = new MngUBrokerProperties;

// If we are creating a new broker, we need to compute somethings, like the UUID.

if (isset($Action) && $Action == "Update") {

  // Make sure the user is authorized to make changes.
  // EditPropertiesAuth is in config.php
  
  if (isset($Authentification) && $Authentification != $EditPropertiesAuth) {
    ?>
    <script language="javascript">alert("Sorry, bad authentification");</script>
    <?php
	
	// Set Action to read so that original values come out of the ubroker.properties
	$Action = "Read";
	
  }
  
  else {

    // SetDefinition expects an array of named settings and their values, construct that...
  
    $ListOfOptions = explode(",", $ListOfSettings);
    foreach ($ListOfOptions as $k => $v) {
      $BrokerOptions[$v] = $_POST [$v];
      if ($v == "appserviceNameList") $BrokerName = $BrokerOptions[$v];
    }
  
    // Call into our ubroker manipulation class to get some stuff done.
  
    $Manager->Load($DLC . "properties/ubroker.properties");  
    $Manager->SetDefinition($BrokerName, $BrokerOptions);
    $Manager->Save($DLC . "properties/ubroker.properties");
  
    // Bring up the same broker definition in the screen so it doesn't confuse the user.
  
    $Definition = $Manager->GetDefinition($BrokerName);
  
    unset($Settings);
  
    $iIter = 0;
    foreach($Definition as $k => $v) {
      $Settings[$iIter++] = $k . "=" . $v;
    } // foreach
  } // else 
}

// If we are updating an existing broker, we will receive the attributes associated with it.
// These may not be all the attributes like above, but we don't add them because we are unsure
// of what their actual defaults might be on the system.

if (isset($Action) && $Action == "Read") {

  $Manager->Load($DLC . "properties/ubroker.properties");
  $Definition = $Manager->GetDefinition($name);
  
  unset($Settings);
  
  $iIter = 0;
  foreach($Definition as $k => $v) {
    $Settings[$iIter++] = $k . "=" . $v;
  }
}

// How we remember what settings we actually had to work with...

$ListOfSettings = "";
foreach($Settings as $k => $v) {
  $Entry = explode("=", $v);
  $ListOfSettings = $ListOfSettings . "," . $Entry[0];
}

?>
<html>
<head>
<title>phpWSAdmin</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="basestyle.css" rel="stylesheet" type="text/css">
</head>

<body bgcolor="#FFFFFF" background="images/bgimg.jpg">
<table width="90%"  border="0" align="center">
  <tr>
    <td bgcolor="#FFFFFF"><?php include_once("menu.php") ?></td>
  </tr>
  <tr>
    <td bgcolor="#FFFFFF"><form name="form1" method="post">
	<input type="hidden" name="Action" value="Update">
	<input type="hidden" name="ListOfSettings" value="<?php echo $ListOfSettings ?>">
      <p>&nbsp;</p>
      <p>&nbsp;</p>
      <table width="80%"  border="0" align="center">
	    <?php 	$BGColor="#FFFFFF"; ?>
        <tr bgcolor="<?php echo $BGColor  ?>">
          <td align="right">Authentication:</td>
          <td><input name="Authentification" type="text" value="" size="60"></td>
        </tr>	  
	    <?php
	    foreach ($Settings as $k => $v) {
		  $Item = explode("=", $v);
		  $BGColor == "#FFFFFF" ? $BGColor = "#96B4B9" : $BGColor = "#FFFFFF";
	    ?>
        <tr bgcolor="<?php echo $BGColor  ?>">
          <td align="right"><?php echo $Item[0] ?>
          </td>
          <td><input name="<?php echo $Item[0] ?>" type="text" value="<?php echo $Item[1] ?>" size="60"></td>
        </tr>
		<?php
		}
		?>
        <tr>
          <td colspan="2"><div align="center">
            <input type="submit" name="Submit" value="Submit">
          </div></td>
          </tr>
      </table>
      <p>&nbsp;</p>  
      </form>    
    <p align="center" class="NormalText">If you wish to make major modifications to a broker definition<br>
      that does not have all the attributes, you may want to create a <br>
      new definition with what you want with the same name, thereby replacing the old one. </p>
    <p align="center" class="NormalText">(The appServiceNameList is the name of the broker!)       </p></td>
  </tr>
</table>
</body>
</html>
